#include <smoothx.h>
#include "fileinfo.h"
#include "codec.h"
#include <id3.h>

fileInfo::fileInfo(SMOOTHString filename)
{
	SMOOTHPoint	 pos;
	SMOOTHSize	 size;
	BONKdecoder	*fdeco;
	InStream	*fi_in;

	id3v2 = SMOOTH::False;

	if (filename == lastfn)
	{
		fdeco = &deco;
		fi_in = fdeco->f_in;
	}
	else
	{
		fdeco = new BONKdecoder;
		fi_in = new InStream(STREAM_FILE, filename);

		fdeco->begin(fi_in);
	}

	mainWnd			= new SMOOTHWindow("Bonk file info");
	mainWnd_titlebar	= new SMOOTHTitlebar(false, false, true);
	divbar			= new SMOOTHDivisionbar(42, OR_HORZ | OR_BOTTOM);
	mainWnd_layer		= new SMOOTHLayer();

	pos.x = 175;
	pos.y = 29;
	size.cx = 0;
	size.cy = 0;

	btn_update		= new SMOOTHButton("Update", NIL, pos, size, SMOOTHProc(fileInfo, this, Update));
	btn_update->SetOrientation(OR_LOWERRIGHT);

	pos.x -= 88;

	btn_close			= new SMOOTHButton("Close", NIL, pos, size, SMOOTHProc(fileInfo, this, Close));
	btn_close->SetOrientation(OR_LOWERRIGHT);

	pos.x = 6;
	pos.y = 10;

	text_filename			= new SMOOTHText("File/URL:", pos);

	pos.x += 53;
	pos.y -= 3;
	size.cx = 427;
	size.cy = 0;

	edit_filename			= new SMOOTHEditBox(filename, pos, size, EDB_ALPHANUMERIC, 0, NULLPROC);
	edit_filename->Deactivate();

	pos.x = 7;
	pos.y = 38;
	size.cx = 321;
	size.cy = 174;

	group_id3v2			= new SMOOTHGroupBox("ID3v2", pos, size);

	pos.x += 58;
	pos.y += 11;
	size.cx = 80;
	size.cy = 0;

	check_id3v2			= new SMOOTHCheckBox("ID3v2 tag", pos, size, &id3v2, SMOOTHProc(fileInfo, this, ToggleID3v2));

	pos.x += 177;
	pos.y += 2;

	text_id3v2_track		= new SMOOTHText("Track #", pos);
	if (!id3v2) text_id3v2_track->Deactivate();

	pos.x += 46;
	pos.y -= 3;
	size.cx = 30;

	edit_id3v2_track		= new SMOOTHEditBox("", pos, size, EDB_NUMERIC, 2, NULLPROC);
	if (!id3v2) edit_id3v2_track->Deactivate();

	pos.x -= 248;
	pos.y += 30;

	text_id3v2_title		= new SMOOTHText("Title", pos);
	if (!id3v2) text_id3v2_title->Deactivate();

	pos.x += 28;
	pos.y -= 3;
	size.cx = 250;

	edit_id3v2_title		= new SMOOTHEditBox("", pos, size, EDB_ALPHANUMERIC, 0, NULLPROC);
	if (!id3v2) edit_id3v2_title->Deactivate();

	pos.x -= 31;
	pos.y += 30;

	text_id3v2_artist		= new SMOOTHText("Artist", pos);
	if (!id3v2) text_id3v2_artist->Deactivate();

	pos.x += 31;
	pos.y -= 3;

	edit_id3v2_artist		= new SMOOTHEditBox("", pos, size, EDB_ALPHANUMERIC, 0, NULLPROC);
	if (!id3v2) edit_id3v2_artist->Deactivate();

	pos.x -= 37;
	pos.y += 30;

	text_id3v2_album		= new SMOOTHText("Album", pos);
	if (!id3v2) text_id3v2_album->Deactivate();

	pos.x += 37;
	pos.y -= 3;

	edit_id3v2_album		= new SMOOTHEditBox("", pos, size, EDB_ALPHANUMERIC, 0, NULLPROC);
	if (!id3v2) edit_id3v2_album->Deactivate();

	pos.x -= 30;
	pos.y += 30;

	text_id3v2_year			= new SMOOTHText("Year", pos);
	if (!id3v2) text_id3v2_year->Deactivate();

	pos.x += 30;
	pos.y -= 3;
	size.cx = 40;

	edit_id3v2_year			= new SMOOTHEditBox("", pos, size, EDB_NUMERIC, 4, NULLPROC);
	if (!id3v2) edit_id3v2_year->Deactivate();

	pos.x += 47;
	pos.y += 3;

	text_id3v2_genre		= new SMOOTHText("Genre", pos);
	if (!id3v2) text_id3v2_genre->Deactivate();

	pos.x += 37;
	pos.y -= 3;
	size.cx = 166;

	combo_id3v2_genre		= new SMOOTHComboBox(pos, size, NULLPROC);
	combo_id3v2_genre->AddEntry("", NULLPROC);
	combo_id3v2_genre->AddEntry("A Cappella", NULLPROC);
	combo_id3v2_genre->AddEntry("Acid", NULLPROC);
	combo_id3v2_genre->AddEntry("Acid Jazz", NULLPROC);
	combo_id3v2_genre->AddEntry("Acid Punk", NULLPROC);
	combo_id3v2_genre->AddEntry("Acoustic", NULLPROC);
	combo_id3v2_genre->AddEntry("Alt. Rock", NULLPROC);
	combo_id3v2_genre->AddEntry("Alternative", NULLPROC);
	combo_id3v2_genre->AddEntry("Ambient", NULLPROC);
	combo_id3v2_genre->AddEntry("Anime", NULLPROC);
	combo_id3v2_genre->AddEntry("Avantgarde", NULLPROC);
	combo_id3v2_genre->AddEntry("Ballad", NULLPROC);
	combo_id3v2_genre->AddEntry("Bass", NULLPROC);
	combo_id3v2_genre->AddEntry("Beat", NULLPROC);
	combo_id3v2_genre->AddEntry("Bebob", NULLPROC);
	combo_id3v2_genre->AddEntry("Big Band", NULLPROC);
	combo_id3v2_genre->AddEntry("Black Metal", NULLPROC);
	combo_id3v2_genre->AddEntry("Bluegrass", NULLPROC);
	combo_id3v2_genre->AddEntry("Blues", NULLPROC);
	combo_id3v2_genre->AddEntry("Booty Bass", NULLPROC);
	combo_id3v2_genre->AddEntry("BritPop", NULLPROC);
	combo_id3v2_genre->AddEntry("Cabaret", NULLPROC);
	combo_id3v2_genre->AddEntry("Celtic", NULLPROC);
	combo_id3v2_genre->AddEntry("Chamber Music", NULLPROC);
	combo_id3v2_genre->AddEntry("Chanson", NULLPROC);
	combo_id3v2_genre->AddEntry("Chorus", NULLPROC);
	combo_id3v2_genre->AddEntry("Christian Gangsta Rap", NULLPROC);
	combo_id3v2_genre->AddEntry("Christian Rap", NULLPROC);
	combo_id3v2_genre->AddEntry("Christian Rock", NULLPROC);
	combo_id3v2_genre->AddEntry("Classic Rock", NULLPROC);
	combo_id3v2_genre->AddEntry("Classical", NULLPROC);
	combo_id3v2_genre->AddEntry("Club", NULLPROC);
	combo_id3v2_genre->AddEntry("Club-House", NULLPROC);
	combo_id3v2_genre->AddEntry("Comedy", NULLPROC);
	combo_id3v2_genre->AddEntry("Contemporary Christian", NULLPROC);
	combo_id3v2_genre->AddEntry("Country", NULLPROC);
	combo_id3v2_genre->AddEntry("Cover", NULLPROC);
	combo_id3v2_genre->AddEntry("Crossover", NULLPROC);
	combo_id3v2_genre->AddEntry("Cult", NULLPROC);
	combo_id3v2_genre->AddEntry("Dance", NULLPROC);
	combo_id3v2_genre->AddEntry("Dance Hall", NULLPROC);
	combo_id3v2_genre->AddEntry("Darkwave", NULLPROC);
	combo_id3v2_genre->AddEntry("Death Metal", NULLPROC);
	combo_id3v2_genre->AddEntry("Disco", NULLPROC);
	combo_id3v2_genre->AddEntry("Dream", NULLPROC);
	combo_id3v2_genre->AddEntry("Drum & Bass", NULLPROC);
	combo_id3v2_genre->AddEntry("Drum Solo", NULLPROC);
	combo_id3v2_genre->AddEntry("Duet", NULLPROC);
	combo_id3v2_genre->AddEntry("Easy Listening", NULLPROC);
	combo_id3v2_genre->AddEntry("Electronic", NULLPROC);
	combo_id3v2_genre->AddEntry("Ethnic", NULLPROC);
	combo_id3v2_genre->AddEntry("Eurodance", NULLPROC);
	combo_id3v2_genre->AddEntry("Euro-House", NULLPROC);
	combo_id3v2_genre->AddEntry("Euro-Techno", NULLPROC);
	combo_id3v2_genre->AddEntry("Fast-Fusion", NULLPROC);
	combo_id3v2_genre->AddEntry("Folk", NULLPROC);
	combo_id3v2_genre->AddEntry("Folk/Rock", NULLPROC);
	combo_id3v2_genre->AddEntry("Folklore", NULLPROC);
	combo_id3v2_genre->AddEntry("Freestyle", NULLPROC);
	combo_id3v2_genre->AddEntry("Funk", NULLPROC);
	combo_id3v2_genre->AddEntry("Fusion", NULLPROC);
	combo_id3v2_genre->AddEntry("Game", NULLPROC);
	combo_id3v2_genre->AddEntry("Gangsta Rap", NULLPROC);
	combo_id3v2_genre->AddEntry("Goa", NULLPROC);
	combo_id3v2_genre->AddEntry("Gospel", NULLPROC);
	combo_id3v2_genre->AddEntry("Gothic", NULLPROC);
	combo_id3v2_genre->AddEntry("Gothic Rock", NULLPROC);
	combo_id3v2_genre->AddEntry("Grunge", NULLPROC);
	combo_id3v2_genre->AddEntry("Hard Rock", NULLPROC);
	combo_id3v2_genre->AddEntry("Hardcore", NULLPROC);
	combo_id3v2_genre->AddEntry("Heavy Metal", NULLPROC);
	combo_id3v2_genre->AddEntry("Hip-Hop", NULLPROC);
	combo_id3v2_genre->AddEntry("House", NULLPROC);
	combo_id3v2_genre->AddEntry("Humour", NULLPROC);
	combo_id3v2_genre->AddEntry("Indie", NULLPROC);
	combo_id3v2_genre->AddEntry("Industrial", NULLPROC);
	combo_id3v2_genre->AddEntry("Instrumental", NULLPROC);
	combo_id3v2_genre->AddEntry("Instrumental Pop", NULLPROC);
	combo_id3v2_genre->AddEntry("Instrumental Rock", NULLPROC);
	combo_id3v2_genre->AddEntry("Jazz", NULLPROC);
	combo_id3v2_genre->AddEntry("Jazz+Funk", NULLPROC);
	combo_id3v2_genre->AddEntry("JPop", NULLPROC);
	combo_id3v2_genre->AddEntry("Jungle", NULLPROC);
	combo_id3v2_genre->AddEntry("Latin", NULLPROC);
	combo_id3v2_genre->AddEntry("Lo-Fi", NULLPROC);
	combo_id3v2_genre->AddEntry("Meditative", NULLPROC);
	combo_id3v2_genre->AddEntry("Merengue", NULLPROC);
	combo_id3v2_genre->AddEntry("Metal", NULLPROC);
	combo_id3v2_genre->AddEntry("Musical", NULLPROC);
	combo_id3v2_genre->AddEntry("National Folk", NULLPROC);
	combo_id3v2_genre->AddEntry("Native American", NULLPROC);
	combo_id3v2_genre->AddEntry("Negerpunk", NULLPROC);
	combo_id3v2_genre->AddEntry("New Age", NULLPROC);
	combo_id3v2_genre->AddEntry("New Wave", NULLPROC);
	combo_id3v2_genre->AddEntry("Noise", NULLPROC);
	combo_id3v2_genre->AddEntry("Oldies", NULLPROC);
	combo_id3v2_genre->AddEntry("Opera", NULLPROC);
	combo_id3v2_genre->AddEntry("Other", NULLPROC);
	combo_id3v2_genre->AddEntry("Polka", NULLPROC);
	combo_id3v2_genre->AddEntry("Polsk Punk", NULLPROC);
	combo_id3v2_genre->AddEntry("Pop", NULLPROC);
	combo_id3v2_genre->AddEntry("Pop/Funk", NULLPROC);
	combo_id3v2_genre->AddEntry("Pop-Folk", NULLPROC);
	combo_id3v2_genre->AddEntry("Porn Groove", NULLPROC);
	combo_id3v2_genre->AddEntry("Power Ballad", NULLPROC);
	combo_id3v2_genre->AddEntry("Pranks", NULLPROC);
	combo_id3v2_genre->AddEntry("Primus", NULLPROC);
	combo_id3v2_genre->AddEntry("Progressive Rock", NULLPROC);
	combo_id3v2_genre->AddEntry("Psychedelic", NULLPROC);
	combo_id3v2_genre->AddEntry("Psychedelic Rock", NULLPROC);
	combo_id3v2_genre->AddEntry("Punk", NULLPROC);
	combo_id3v2_genre->AddEntry("Punk Rock", NULLPROC);
	combo_id3v2_genre->AddEntry("R&B", NULLPROC);
	combo_id3v2_genre->AddEntry("Rap", NULLPROC);
	combo_id3v2_genre->AddEntry("Rave", NULLPROC);
	combo_id3v2_genre->AddEntry("Reggae", NULLPROC);
	combo_id3v2_genre->AddEntry("Remix", NULLPROC);
	combo_id3v2_genre->AddEntry("Retro", NULLPROC);
	combo_id3v2_genre->AddEntry("Revival", NULLPROC);
	combo_id3v2_genre->AddEntry("Rhythmic Soul", NULLPROC);
	combo_id3v2_genre->AddEntry("Rock", NULLPROC);
	combo_id3v2_genre->AddEntry("Rock & Roll", NULLPROC);
	combo_id3v2_genre->AddEntry("Salsa", NULLPROC);
	combo_id3v2_genre->AddEntry("Samba", NULLPROC);
	combo_id3v2_genre->AddEntry("Satire", NULLPROC);
	combo_id3v2_genre->AddEntry("Showtunes", NULLPROC);
	combo_id3v2_genre->AddEntry("Ska", NULLPROC);
	combo_id3v2_genre->AddEntry("Slow Jam", NULLPROC);
	combo_id3v2_genre->AddEntry("Slow Rock", NULLPROC);
	combo_id3v2_genre->AddEntry("Sonata", NULLPROC);
	combo_id3v2_genre->AddEntry("Soul", NULLPROC);
	combo_id3v2_genre->AddEntry("Sound Clip", NULLPROC);
	combo_id3v2_genre->AddEntry("Soundtrack", NULLPROC);
	combo_id3v2_genre->AddEntry("Southern Rock", NULLPROC);
	combo_id3v2_genre->AddEntry("Space", NULLPROC);
	combo_id3v2_genre->AddEntry("Speech", NULLPROC);
	combo_id3v2_genre->AddEntry("Swing", NULLPROC);
	combo_id3v2_genre->AddEntry("Symphonic Rock", NULLPROC);
	combo_id3v2_genre->AddEntry("Symphony", NULLPROC);
	combo_id3v2_genre->AddEntry("Synthpop", NULLPROC);
	combo_id3v2_genre->AddEntry("Tango", NULLPROC);
	combo_id3v2_genre->AddEntry("Techno", NULLPROC);
	combo_id3v2_genre->AddEntry("Techno-Industrial", NULLPROC);
	combo_id3v2_genre->AddEntry("Terror", NULLPROC);
	combo_id3v2_genre->AddEntry("Thrash-Metal", NULLPROC);
	combo_id3v2_genre->AddEntry("Top 40", NULLPROC);
	combo_id3v2_genre->AddEntry("Trailer", NULLPROC);
	combo_id3v2_genre->AddEntry("Trance", NULLPROC);
	combo_id3v2_genre->AddEntry("Tribal", NULLPROC);
	combo_id3v2_genre->AddEntry("Trip-Hop", NULLPROC);
	combo_id3v2_genre->AddEntry("Vocal", NULLPROC);
	if (!id3v2) combo_id3v2_genre->Deactivate();

	pos.x -= 136;
	pos.y += 30;

	text_id3v2_comment		= new SMOOTHText("Comment", pos);
	if (!id3v2) text_id3v2_comment->Deactivate();

	pos.x += 52;
	pos.y -= 3;
	size.cx = 250;

	edit_id3v2_comment		= new SMOOTHEditBox("", pos, size, EDB_ALPHANUMERIC, 0, NULLPROC);
	if (!id3v2) edit_id3v2_comment->Deactivate();

	pos.x = 336;
	pos.y = 38;
	size.cx = 150;
	size.cy = 174;

	group_info			= new SMOOTHGroupBox("File/Stream info", pos, size);

	RegisterObject(mainWnd);

	mainWnd_layer->RegisterObject(btn_close);
	mainWnd_layer->RegisterObject(btn_update);
	mainWnd_layer->RegisterObject(text_filename);
	mainWnd_layer->RegisterObject(edit_filename);
	mainWnd_layer->RegisterObject(group_id3v2);
	mainWnd_layer->RegisterObject(check_id3v2);
	mainWnd_layer->RegisterObject(text_id3v2_title);
	mainWnd_layer->RegisterObject(edit_id3v2_title);
	mainWnd_layer->RegisterObject(text_id3v2_artist);
	mainWnd_layer->RegisterObject(edit_id3v2_artist);
	mainWnd_layer->RegisterObject(text_id3v2_album);
	mainWnd_layer->RegisterObject(edit_id3v2_album);
	mainWnd_layer->RegisterObject(text_id3v2_track);
	mainWnd_layer->RegisterObject(edit_id3v2_track);
	mainWnd_layer->RegisterObject(text_id3v2_year);
	mainWnd_layer->RegisterObject(edit_id3v2_year);
	mainWnd_layer->RegisterObject(text_id3v2_genre);
	mainWnd_layer->RegisterObject(combo_id3v2_genre);
	mainWnd_layer->RegisterObject(text_id3v2_comment);
	mainWnd_layer->RegisterObject(edit_id3v2_comment);
	mainWnd_layer->RegisterObject(group_info);

	mainWnd->RegisterObject(mainWnd_titlebar);
	mainWnd->RegisterObject(mainWnd_layer);
	mainWnd->RegisterObject(divbar);

	mainWnd->SetMetrics(SMOOTHPoint(120, 120), SMOOTHSize(499, 290));

	if (filename != lastfn)
	{
		fdeco->end();

		delete fdeco;
		delete fi_in;
	}
}

fileInfo::~fileInfo()
{
	mainWnd->UnregisterObject(mainWnd_titlebar);
	mainWnd->UnregisterObject(mainWnd_layer);
	mainWnd->UnregisterObject(divbar);

	mainWnd_layer->UnregisterObject(btn_close);
	mainWnd_layer->UnregisterObject(btn_update);
	mainWnd_layer->UnregisterObject(text_filename);
	mainWnd_layer->UnregisterObject(edit_filename);
	mainWnd_layer->UnregisterObject(group_id3v2);
	mainWnd_layer->UnregisterObject(check_id3v2);
	mainWnd_layer->UnregisterObject(text_id3v2_title);
	mainWnd_layer->UnregisterObject(edit_id3v2_title);
	mainWnd_layer->UnregisterObject(text_id3v2_artist);
	mainWnd_layer->UnregisterObject(edit_id3v2_artist);
	mainWnd_layer->UnregisterObject(text_id3v2_album);
	mainWnd_layer->UnregisterObject(edit_id3v2_album);
	mainWnd_layer->UnregisterObject(text_id3v2_track);
	mainWnd_layer->UnregisterObject(edit_id3v2_track);
	mainWnd_layer->UnregisterObject(text_id3v2_year);
	mainWnd_layer->UnregisterObject(edit_id3v2_year);
	mainWnd_layer->UnregisterObject(text_id3v2_genre);
	mainWnd_layer->UnregisterObject(combo_id3v2_genre);
	mainWnd_layer->UnregisterObject(text_id3v2_comment);
	mainWnd_layer->UnregisterObject(edit_id3v2_comment);
	mainWnd_layer->UnregisterObject(group_info);

	UnregisterObject(mainWnd);

	delete mainWnd_titlebar;
	delete mainWnd_layer;
	delete mainWnd;
	delete divbar;
	delete text_filename;
	delete edit_filename;
	delete group_id3v2;
	delete check_id3v2;
	delete text_id3v2_title;
	delete edit_id3v2_title;
	delete text_id3v2_artist;
	delete edit_id3v2_artist;
	delete text_id3v2_album;
	delete edit_id3v2_album;
	delete text_id3v2_track;
	delete edit_id3v2_track;
	delete text_id3v2_year;
	delete edit_id3v2_year;
	delete text_id3v2_genre;
	delete combo_id3v2_genre;
	delete text_id3v2_comment;
	delete edit_id3v2_comment;
	delete group_info;
	delete btn_close;
	delete btn_update;
}

SMOOTHInt fileInfo::ShowDialog()
{
	mainWnd->Stay();

	return mainWnd->value;
}

SMOOTHVoid fileInfo::Update()
{
	SMOOTH::CloseWindow(mainWnd);
}

SMOOTHVoid fileInfo::Close()
{
	SMOOTH::CloseWindow(mainWnd);
}

SMOOTHVoid fileInfo::ToggleID3v2()
{
	if (id3v2)
	{
		text_id3v2_title->Activate();
		edit_id3v2_title->Activate();
		text_id3v2_artist->Activate();
		edit_id3v2_artist->Activate();
		text_id3v2_album->Activate();
		edit_id3v2_album->Activate();
		text_id3v2_track->Activate();
		edit_id3v2_track->Activate();
		text_id3v2_year->Activate();
		edit_id3v2_year->Activate();
		text_id3v2_genre->Activate();
		combo_id3v2_genre->Activate();
		text_id3v2_comment->Activate();
		edit_id3v2_comment->Activate();
	}
	else
	{
		text_id3v2_title->Deactivate();
		edit_id3v2_title->Deactivate();
		text_id3v2_artist->Deactivate();
		edit_id3v2_artist->Deactivate();
		text_id3v2_album->Deactivate();
		edit_id3v2_album->Deactivate();
		text_id3v2_track->Deactivate();
		edit_id3v2_track->Deactivate();
		text_id3v2_year->Deactivate();
		edit_id3v2_year->Deactivate();
		text_id3v2_genre->Deactivate();
		combo_id3v2_genre->Deactivate();
		text_id3v2_comment->Deactivate();
		edit_id3v2_comment->Deactivate();
	}
}
